#include "smtp.h"
extern smtpi jtin;

#define _jabstats_key_singlelist ",stepover,"
#define _jabstats_key_year "year"
#define _jabstats_key_day "day"
#define _jabstats_key_from "from"
#define _jabstats_key_month "month"
#define _jabstats_key_to "to"
#define _jabstats_key_stepover "stepover"

#define _smtpstats_key_singlelist ",stepover,"
#define _smtpstats_key_year "year"
#define _smtpstats_key_day "day"
#define _smtpstats_key_from "from"
#define _smtpstats_key_month "month"
#define _smtpstats_key_to "to"
#define _smtpstats_key_stepover "stepover"

int _smtp_opm_check_JID(char *lcJID,const char *lcNS)
   {
   int liProcess=0;
   xmlnode loAdmin;


   for (loAdmin = xmlnode_get_firstchild(xmlnode_get_tag(jtin->config,"core/admins")); loAdmin != NULL; loAdmin = xmlnode_get_nextsibling(loAdmin))
        {
        if (loAdmin->type!=NTYPE_TAG || strcmp(xmlnode_get_attrib(loAdmin,"xmlns"),lcNS)!=0 )  
           continue;

        if (strcmp(lcJID,xmlnode_get_data(loAdmin))==0)
           {
           liProcess=1;
           break;
           }
        }
   return liProcess;
   }


int _smtp_out_packets_message_admin(smtpp par,int liType,char *lcJID, char *lcMSG)
   {
   int liProcess=0,liDefault;
   char *lcSep, *lcRes, *lcData, *lcNS;
   xmlnode loJID,loMsg;

   switch (liType)
      {
	  case SMTP_ADMIN_JID:
           lcNS=SMTP_ADMIN_NS_JID;
	       break;

      default:
           lcNS=SMTP_ADMIN_NS_EMAIL;

      }

   // Nyn otestuj pjemce, zda to nen admin
   // pokud ano, pak jeho zprvu zpracuj
   // jinak vra Invalid Address
   liProcess=_smtp_opm_check_JID(lcJID,lcNS);

   if (liProcess==1)
      {
      // read first line from message
      lcSep = strstr(lcMSG,"\r");
      if (lcSep==NULL)
          lcSep = strstr(lcMSG,"\n");

      if (lcSep!=NULL)
          *lcSep='\0';

      // Read JID and Data from message
      lcData = strstr(lcMSG," ");
      if (lcData!=NULL)
         {
         *lcData='\0';
         lcData++;

         lcRes = strstr(lcMSG,"/");
         if (lcRes!=NULL)
            {
            *lcRes='\0';
            lcRes++;

            if (strcmp(lcRes,"paid")==0)
               {
               // Get JID item from roster
               loJID=smtp_roster_get_item( lcMSG,1);
               liDefault=j_atoi(xmlnode_get_attrib(loJID,"default"),0);
               xmlnode_put_attrib(loJID,"paid",strcmp(lcData,"Y")==0?"1":"0");
               smtp_roster_set_item(lcMSG,loJID);
               if (liDefault==1) // default item, remove it
                  xmlnode_free(loJID);

               }
            }
         }
       else
         {
         if (strcmp(lcMSG,"login")==0)
            {
            loMsg=out_SetReply(xmlnode_dup_pool(par->tmppool,par->jp->x),par->jp->x);
            xmlnode_put_attrib(loMsg,"type","chat");
            deliver(dpacket_new(xmlnode_dup(loMsg)),par->i);
            smtp_stats_out(loMsg);
            }
         }

      }


   return liProcess;
   }

char *_smtp_opmadmin_getfolder(pool p, char *lcFLD)
   {
   if (j_strcmp(lcFLD,"jb")==0)
      return jtin->jabber_backup;
   else if (j_strcmp(lcFLD,"jbo")==0)
      return spools(p,jtin->jabber_backup,"/old",p);
   else if (j_strcmp(lcFLD,"jo")==0)
      return jtin->jabber_offline;
   else if (j_strcmp(lcFLD,"sb")==0)
      return jtin->smtp_backup;
   else if (j_strcmp(lcFLD,"so")==0)
      return jtin->smtp_offline;
   else if (j_strcmp(lcFLD,"sbo")==0)
      return spools(p,jtin->smtp_backup,"/old",p);
   else if (j_strcmp(lcFLD,"tmp")==0)
      return jtin->core_tmp;
   else
      return NULL;

   return NULL;
   }


int _smtp_opmadmin_getcntfolder(char *lcFLD,int liOld)
   {
   int lii=0;
   struct dirent   *dirp;
   DIR      *dp;

   if ((dp = opendir(lcFLD))==NULL)
      return -1;

   lii=0;
   while ( (dirp = readdir((DIR *)dp)) != NULL)
      {
      if (strcmp(dirp->d_name, ".") == 0  ||
          strcmp(dirp->d_name, "..") == 0 ||
          (liOld=1 && strcmp(dirp->d_name, "old") == 0)
         )
         continue;      // ignore dot and dot-dot 

      lii++;
      }
   closedir((DIR *)dp);
   return lii;
   }

int _smtp_opmadmin_formatfolder(const char *lcFLDX,char *lcFLD, int lii, xmlnode loBody)
   {
   xmlnode_insert_cdata(loBody,lcFLDX,-1);
   xmlnode_insert_cdata(loBody," - ",-1);
   xmlnode_insert_cdata(loBody,lcFLD,-1);
   xmlnode_insert_cdata(loBody," : ",-1);
   xmlnode_insert_cdata(loBody,smtp_itoa(xmlnode_pool(loBody),lii),-1);
   xmlnode_insert_cdata(loBody,"\r\n",-1);


   return lii;
   }

int _smtp_opmadmin_transport(smtpp par,char *lcJID,char *lcMSG)
   {
   int liProcess=0,lii,liFirst=-1;
   char *laWords[5],*lcFolder=NULL,*lcFolderD=NULL, *lcBFile, *lcMax;
   xmlnode x,loBody,loBackup,loFile,loJID;
   struct dirent   *dirp;
   DIR      *dp;
   pool p=par->tmppool;
   
   lcMax=lcMSG+j_strlen(lcMSG);
   laWords[0]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[1]=smtp_getword(&lcMSG, " ",lcMax);

   x= out_SetReply(xmlnode_new_tag("message"),par->jp->x);
   smtp_PoolsReg(1000, xmlnode_pool(x));

   xmlnode_put_attrib(x,"type","chat");
   loBody=xmlnode_insert_tag(x,"body");

   // command stats
   if (liProcess==0 && j_strcmp(laWords[0],"stats")==0)
      {
      if (jtin->tmpBackupJabber==1)
         {
         lcFolder=jtin->jabber_backup;
         lii=_smtp_opmadmin_getcntfolder(lcFolder ,1);
         _smtp_opmadmin_formatfolder("jb",lcFolder ,lii,loBody);

         lcFolder=spools(p,jtin->jabber_backup,"/old",p);
         lii=_smtp_opmadmin_getcntfolder(lcFolder ,0);
         _smtp_opmadmin_formatfolder("jbo",lcFolder ,lii,loBody);
         }

      if (jtin->tmpOfflineJabber==1)
         {
         lcFolder=jtin->jabber_offline;
         lii=_smtp_opmadmin_getcntfolder(lcFolder ,0);
         _smtp_opmadmin_formatfolder("jo",lcFolder ,lii,loBody);
         }

      if (jtin->tmpBackupSMTP==1)
         {
         lcFolder=jtin->smtp_backup;
         lii=_smtp_opmadmin_getcntfolder(lcFolder ,1);
         _smtp_opmadmin_formatfolder("sb",lcFolder ,lii,loBody);

         lcFolder=spools(p,jtin->smtp_backup,"/old",p);
         lii=_smtp_opmadmin_getcntfolder(lcFolder ,0);
         _smtp_opmadmin_formatfolder("sbo",lcFolder ,lii,loBody);
         }

      if (jtin->tmpOfflineSMTP==1)
         {
         lcFolder=jtin->smtp_offline;
         lii=_smtp_opmadmin_getcntfolder(lcFolder ,0);
         _smtp_opmadmin_formatfolder("so",lcFolder ,lii,loBody);
         }

      if (jtin->tmpCoreTmp==1)
         {
         lcFolder=jtin->core_tmp;
         lii=_smtp_opmadmin_getcntfolder(lcFolder ,0);
         _smtp_opmadmin_formatfolder("tmp",lcFolder ,lii,loBody);
         }

      // accounts + payed accounts
      xmlnode_insert_cdata(loBody,"\r\nAccounts: ",-1);
      xmlnode_insert_cdata(loBody,smtp_itoa(p,jtin->Stats->_CoreAccounts),-1);

      lii=0;
      for (loFile = xmlnode_get_tag(jtin->roster_files,"file"); loFile != NULL; loFile = xmlnode_get_nextsibling(loFile))
          {
          if (loFile->type!=NTYPE_TAG)
             continue;

          // walk all jid in file
          for (loJID = xmlnode_get_tag(loFile,"item"); loJID != NULL; loJID = xmlnode_get_nextsibling(loJID))
              {
              if (loJID->type!=NTYPE_TAG || j_atoi(xmlnode_get_attrib(loJID,"paid"),0)==0)
                  continue;

              lii++;
              }
          }

      xmlnode_insert_cdata(loBody,"\r\nAccounts-paid: ",-1);
      xmlnode_insert_cdata(loBody,smtp_itoa(p,lii),-1);
      xmlnode_insert_cdata(loBody,"\r\n",-1);


      xmlnode_insert_cdata(loBody,"\r\nCPU-Usage: ",-1);
      xmlnode_insert_cdata(loBody,smtp_itoa(p,jtin->Stats->CPUUsage),-1);
      xmlnode_insert_cdata(loBody,"\r\n",-1);

      liProcess=1;
      }

   // command ls
   if (liProcess==0 && j_strcmp(laWords[0],"ls")==0 && j_strlen(laWords[1])>0)
      {
      laWords[2]=smtp_getword(&lcMSG, " ",lcMax);
      lcFolder=_smtp_opmadmin_getfolder(p,laWords[1]);
      if (j_strlen(laWords[2])>0 && strncasecmp(laWords[2],"/f",2)==0)
         liFirst=j_atoi((laWords[2]+2),-1);

      if (j_strlen(lcFolder)>0)
         {
         if ((dp = opendir(lcFolder))!=NULL)
            {
            lii=0;
            while ( (dirp = readdir((DIR *)dp)) != NULL)
                  {
                  if (strcmp(dirp->d_name, ".") == 0  ||
                      strcmp(dirp->d_name, "..") == 0 ||
                      strcmp(dirp->d_name, "old") == 0)
                      continue;      // ignore dot and dot-dot 

                  if (lii>0)
                     xmlnode_insert_cdata(loBody," | ",-1);

                  xmlnode_insert_cdata(loBody,dirp->d_name,-1);

                  lii++;
                  if (liFirst>0 && lii==(liFirst-1))
                      break;
                  }

            closedir((DIR *)dp);
            xmlnode_insert_cdata(loBody,"\r\n",-1);

            if (lii==0)
               {
               xmlnode_insert_cdata(loBody,lcFolder,-1);
               xmlnode_insert_cdata(loBody," : ",-1);
               xmlnode_insert_cdata(loBody,smtp_itoa(p,lii),-1);
               xmlnode_insert_cdata(loBody,"\r\n",-1);
               }
            }
         else
            {
            xmlnode_insert_cdata(loBody,lcFolder,-1);
            xmlnode_insert_cdata(loBody," : failed\r\n",-1);
            }
         }
      else
         {
         xmlnode_insert_cdata(loBody,"Folder unknown\r\n",-1);
         }
      liProcess=1;
      }

   // command get
   if (liProcess==0 && j_strcmp(laWords[0],"get")==0 && j_strlen(laWords[1])>0)
      {
      laWords[2]=smtp_getword(&lcMSG, " ",lcMax);
      lcFolder=_smtp_opmadmin_getfolder(p,laWords[1]);

      if (j_strlen(laWords[2])>0 && j_strlen(lcFolder)>0)
         {
         loBackup=xmlnode_file(spools(p,lcFolder,"/",laWords[2],p));
         smtp_PoolsReg(2220, xmlnode_pool(loBackup));

         if (loBackup==NULL)
            xmlnode_insert_cdata(loBody,"Cannot read file\r\n",-1);
         else
            {
            xmlnode_insert_cdata(loBody,xmlnode2str(loBackup),-1);
            xmlnode_free(loBackup);
            }
         }
      else
         {
         if (j_strlen(lcFolder)==0)
            xmlnode_insert_cdata(loBody,"Folder unknown\r\n",-1);

         if (j_strlen(laWords[2])==0)
            xmlnode_insert_cdata(loBody,"File unknown\r\n",-1);

         }
      liProcess=1;
      }

   // command rm
   if (liProcess==0 && j_strcmp(laWords[0],"rm")==0)
      {
      laWords[2]=smtp_getword(&lcMSG, " ",lcMax);
      laWords[3]=smtp_getword(&lcMSG, " ",lcMax);

      lcFolder=_smtp_opmadmin_getfolder(p,laWords[1]);

      if (j_strlen(laWords[3])>0 && strncasecmp(laWords[3],"/f",2)==0)
         liFirst=j_atoi((laWords[3]+2),-1);

      if (j_strlen(laWords[2])>0 && strncasecmp(laWords[2],"/f",2)==0)
         liFirst=j_atoi((laWords[2]+2),-1);

      if (j_strlen(lcFolder)>0)
         {
         if (j_strlen(laWords[2])>0)
            {
            remove(spools(p,lcFolder,"/",laWords[2],p));
            xmlnode_insert_cdata(loBody,"File deleted\r\n",-1);
            }
         else
            {
            lii=0;
            if ((dp = opendir(lcFolder))!=NULL)
               {
               while ( (dirp = readdir((DIR *)dp)) != NULL)
                  {
                  if (strcmp(dirp->d_name, ".") == 0  ||
                      strcmp(dirp->d_name, "..") == 0 ||
                      strcmp(dirp->d_name, "old") == 0)
                      continue;      // ignore dot and dot-dot 

                  remove(spools(p,lcFolder,"/",dirp->d_name,p));
                  lii++;

                  if (liFirst>0 && lii==(liFirst-1))
                      break;
                  }
               closedir((DIR *)dp);

               xmlnode_insert_cdata(loBody,lcFolder,-1);
               xmlnode_insert_cdata(loBody," : ",-1);
               xmlnode_insert_cdata(loBody,smtp_itoa(p,lii),-1);
               xmlnode_insert_cdata(loBody,"\r\n",-1);
               }
            else
               {
               xmlnode_insert_cdata(loBody,"Cannot open ",-1);
               xmlnode_insert_cdata(loBody,lcFolder,-1);
               xmlnode_insert_cdata(loBody,"\r\n",-1);
               }

            xmlnode_insert_cdata(loBody,"All files deleted\r\n",-1);
            }
         }
      else
         xmlnode_insert_cdata(loBody,"Folder unknown\r\n",-1);

      liProcess=1;
      }

   // command mv
   if (liProcess==0 && j_strcmp(laWords[0],"mv")==0)
      {
      laWords[2]=smtp_getword(&lcMSG, " ",lcMax);
      laWords[3]=smtp_getword(&lcMSG, " ",lcMax);
      laWords[4]=smtp_getword(&lcMSG, " ",lcMax);

      lcFolder=_smtp_opmadmin_getfolder(p,laWords[1]);
      lcFolderD=_smtp_opmadmin_getfolder(p,laWords[2]);

      if (j_strlen(laWords[4])>0 && strncasecmp(laWords[4],"/f",2)==0)
         liFirst=j_atoi((laWords[4]+2),-1);

      if (j_strlen(laWords[3])>0 && strncasecmp(laWords[3],"/f",2)==0)
         liFirst=j_atoi((laWords[3]+2),-1);

      if (j_strlen(lcFolder)>0 && j_strlen(lcFolderD)>0)
         {
         if (j_strlen(laWords[3])>0)
            {
            lcBFile = (char*)pmalloco(p, 254);
            lcBFile[-1] = '\0';
            lcBFile=spools(p, tempnam(lcFolderD, "tmp"),".xml",p);

            rename(spools(p,lcFolder,"/", laWords[3] ,p), lcBFile);
            xmlnode_insert_cdata(loBody,"File moved\r\n",-1);
            }
         else
            {
            lii=0;
            if ((dp = opendir(lcFolder))!=NULL)
               {
               while ( (dirp = readdir((DIR *)dp)) != NULL)
                  {
                  if (strcmp(dirp->d_name, ".") == 0  ||
                      strcmp(dirp->d_name, "..") == 0 ||
                      strcmp(dirp->d_name, "old") == 0)
                      continue;      // ignore dot and dot-dot 

                  lcBFile = (char*)pmalloco(p, 254);
                  lcBFile[-1] = '\0';
                  lcBFile=spools(p, tempnam(lcFolderD, "tmp"),".xml",p);

                  rename(spools(p,lcFolder,"/", dirp->d_name,p),lcBFile);
                  lii++;

                  if (liFirst>0 && lii==(liFirst-1))
                      break;
                  }
               closedir((DIR *)dp);

               xmlnode_insert_cdata(loBody,lcFolder,-1);
               xmlnode_insert_cdata(loBody," : ",-1);
               xmlnode_insert_cdata(loBody,smtp_itoa(p,lii),-1);
               xmlnode_insert_cdata(loBody,"\r\n",-1);
               }
            else
               {
               xmlnode_insert_cdata(loBody,"Cannot open ",-1);
               xmlnode_insert_cdata(loBody,lcFolder,-1);
               xmlnode_insert_cdata(loBody,"\r\n",-1);
               }
            }
         }
      else
         {
         if (j_strlen(lcFolder)==0)
             xmlnode_insert_cdata(loBody,"Source folder unknown\r\n",-1);

         if (j_strlen(lcFolderD)==0)
             xmlnode_insert_cdata(loBody,"Destination folder unknown\r\n",-1);

         }

      liProcess=1;
      }


/*
// sloky backup a offline
//!transport stats - vrt info o poctu soubor v jabber, jabber/old,jabber-offline, smtp a smtp/old
//!transport ls jb[jbo, jo, sb, sbo] /fxxxx - vrt seznam soubor z 
//    jb  - jabber backup
//    jbo - jabber backup-old
//    jo  - jabber offline
//    sb  - smtp backup
//    sbo - smtp backup-old
//    tmp - tmp

//!transport get xxx [file name] - vrt soubor ze sloky uren xxx, viz !ls
//!transport rm xxx [file name]  /fxxxx - smae soubor ve sloce uren xxx, viz !ls
//!transport mv xxx yyy [file name] /fxxxx - pesune  soubor ze sloky xxx, do yyy !ls

*/

   if (liProcess==1)
      {
      deliver(dpacket_new(xmlnode_dup(x)),par->i);
      smtp_stats_out(x);
      }
 
   xmlnode_free(x);

   return liProcess;
   }
int _smtp_opmadmin_config(smtpp par,char *lcJID,char *lcMSG)
   {
   char *laWords[5],*lcMax;
   int liProcess=0;
   xmlnode x,loBody,loNode;
/*
// config
// !config get  - vrt cel konfig
!config set [vtev] hodnota - ulo xml string do vtv  ?!?
!config set [vtev:cdata] hodnota - ulo hodnotu do vtv
!config set [vtev?atribut] hodnota - ulo hodnotu do vtve a atributu
//!config save - ulo konfig do souboru
*/


   lcMax=lcMSG+j_strlen(lcMSG);
   laWords[0]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[1]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[2]=smtp_getword(&lcMSG, " ",lcMax);
   
   x= out_SetReply(xmlnode_new_tag("message"),par->jp->x);
   smtp_PoolsReg(1010, xmlnode_pool(x));

   xmlnode_put_attrib(x,"type","chat");
   loBody=xmlnode_insert_tag(x,"body");

   if (liProcess==0 && j_strcmp(laWords[0],"get")==0)
      {
      // vra cel konfig
      if (j_strlen(laWords[1])==0 && j_strlen(laWords[2])==0)
         xmlnode_insert_cdata(loBody,xmlnode2str(jtin->config),-1);

      // vrat data z nodu
      // laWords[1] obsahuje vbrov kritria
      // laWords[2] obsahuje typ vrcen (:xml, :cdata, ?atribute_name
      if (j_strlen(laWords[1])>0 && j_strlen(laWords[2])>0)
         {
          
         if (strcasecmp(laWords[2],":xml")==0) // get XML data from branch
            {
            loNode=xmlnode_get_tag(jtin->config,laWords[1]);
            if (loNode==NULL)
               xmlnode_insert_cdata(loBody,"Node not found.",-1);
            else
               xmlnode_insert_cdata(loBody,xmlnode2str(loNode),-1);
            }

         if (strcasecmp(laWords[2],":cdata")==0) // get data to branch
            {
            loNode=xmlnode_get_tag(jtin->config,laWords[1]);
            if (loNode==NULL)
               xmlnode_insert_cdata(loBody,"Node not found.",-1);
            else
               xmlnode_insert_cdata(loBody,xmlnode_get_data(loNode),-1);
            }

         if (*laWords[2]=='?') // get data from branch attribute
            {
            *laWords[2]='\0';
            laWords[2]++;

            loNode=xmlnode_get_tag(jtin->config,laWords[1]);
            if (loNode==NULL)
               xmlnode_insert_cdata(loBody,"Node not found.",-1);
            else
               {
               xmlnode_insert_cdata(loBody,xmlnode_get_attrib(loNode,laWords[2]),-1);
               }

            }

         }

      liProcess=1;
      }


   if (liProcess==0 && j_strcmp(laWords[0],"save")==0)
      {
      if (xmlnode2file(jtin->config_file,jtin->config)!=1)
         xmlnode_insert_cdata(loBody,"Config not saved.",-1);
      else
         xmlnode_insert_cdata(loBody,"Config saved.",-1);

      liProcess=1;
      }

   if (liProcess==1)
      {
      deliver(dpacket_new(xmlnode_dup(x)),par->i);
      smtp_stats_out(x);
      }
 
   xmlnode_free(x);

   return liProcess;
   }

void _smtp_opmadmin_account_enum(void *luArg, char *lcJID)
   {
   spool loList= (spool)luArg;
   if (loList->len==0)
      spool_add(loList,lcJID);
   else
      spooler(loList," | ",lcJID,loList);
   }


int _smtp_opmadmin_account(smtpp par,char *lcJID,char *lcMSG)
   {
/*
// accounts
!account rm index/letter - smae soubor z indexovho souboru
!account rm file/letter - smae soubor s ty


!account check - Zkontroluje zda jsou vechny JID pod sprvmi ty-psmeny 

!account ls index - vrt seznam soubor z indexovho souboru

!account list - vrt seznam t JID
!account list/letter - vrt seznam JID t dle prvnho psmena

!account get [jid] - vrt et pro JID
!account set [jid] - nastav et pro JID , xml must be on the same row row

!account remove  [jid] cl - odstran jid ze souboru + odstran kontakt list
!account remove/letter [group] [jid] cl - odstran jid ze souboru + odstran kontakt list

*/

   int liProcess=0;
   char *laWords[5], *lcMax, *lcLetter,*lcFrom;
   xmlnode x,loBody,loJID,loFile;
   pool p=par->tmppool; 
   spool loList;

   x= out_SetReply(xmlnode_new_tag("message"),par->jp->x);
   smtp_PoolsReg(1005, xmlnode_pool(x));

   xmlnode_put_attrib(x,"type","chat");
   loBody=xmlnode_insert_tag(x,"body");

   lcMax=lcMSG+j_strlen(lcMSG);
   laWords[0]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[1]=smtp_getword(&lcMSG, " ",lcMax);



   // rm index/letter (psmeno)
   // odstra zznam o skupin z hlavnho souboru
   if (liProcess==0 && j_strcmp(laWords[0],"rm")==0 && j_strcmp(laWords[1],"index/letter")==0 && j_strlen(laWords[2])>0)
      {
      if ((loFile=xmlnode_get_tag(jtin->roster,spools(p,"file?type=",laWords[2],p)))!=NULL)
         {
         xmlnode_insert_cdata(loBody,"Roster index",-1);
         xmlnode_insert_cdata(loBody," ",-1);
         xmlnode_insert_cdata(loBody,laWords[2],-1);
         xmlnode_insert_cdata(loBody," removed",-1);
         xmlnode_hide(loFile);
         smtp_roster_save_main();
         }
      liProcess=1;
      }

   // rm file/letter (psmeno)
   // odstra skupinu  
   if (liProcess==0 && j_strcmp(laWords[0],"rm")==0 && j_strcmp(laWords[1],"file/letter")==0 && j_strlen(laWords[2])>0)
      {
      xmlnode_insert_cdata(loBody,"Roster file",-1);
      xmlnode_insert_cdata(loBody," ",-1);
      xmlnode_insert_cdata(loBody,laWords[2],-1);
      xmlnode_insert_cdata(loBody," removed",-1);
      remove(spools(p,jtin->roster_folder,"/roster_",laWords[2],".xml",p));
      liProcess=1;
      }

   // ls index
   if (liProcess==0 && j_strcmp(laWords[0],"ls")==0 && j_strcmp(laWords[1],"index")==0)
      {
      loList=spool_new(p);

      for (loFile = xmlnode_get_firstchild(jtin->roster); loFile != NULL; loFile = xmlnode_get_nextsibling(loFile))
          {
          if (loFile->type!=NTYPE_TAG)
              continue;


          lcLetter = xmlnode_get_attrib(loFile,"type");
          xmlnode_insert_cdata(loBody,"(",-1);
          xmlnode_insert_cdata(loBody,lcLetter,-1);
          xmlnode_insert_cdata(loBody,") ",-1);
          fromEscape(lcLetter,(void *)lcLetter);
          xmlnode_insert_cdata(loBody,lcLetter,-1);
          xmlnode_insert_cdata(loBody," ",-1);
          xmlnode_insert_cdata(loBody,xmlnode_get_data(loFile),-1);
          xmlnode_insert_cdata(loBody,"\r\n",-1);
          }

      liProcess=1;
      }

   // command list
   if (liProcess==0 && j_strcmp(laWords[0],"list")==0)
      {
      loList=spool_new(p);
      smtp_roster_enum( NULL, (void *) _smtp_opmadmin_account_enum,(void *)loList);

      xmlnode_insert_cdata(loBody,spool_print(loList),-1);
      liProcess=1;
      }

   // command list/letter
   if (liProcess==0 && j_strcmp(laWords[0],"list/letter")==0 && j_strlen(laWords[1])>0)
      {
      loList=spool_new(p);
      smtp_roster_enum( laWords[1], (void *) _smtp_opmadmin_account_enum,(void *)loList);

      xmlnode_insert_cdata(loBody,spool_print(loList),-1);
      liProcess=1;
      }



   // command get
   if (liProcess==0 && j_strcmp(laWords[0],"get")==0 && j_strlen(laWords[1])>0)
      {
      if ((loJID=smtp_roster_get_item(laWords[1],0))!=NULL)
         {
         xmlnode_insert_cdata(loBody,"letter ",-1);
         xmlnode_insert_cdata(loBody,xmlnode_get_attrib(xmlnode_get_parent(loJID),"type"),-1);
         xmlnode_insert_cdata(loBody,"\r\n",-1);
         xmlnode_insert_cdata(loBody,xmlnode2str(xmlnode_dup_pool(p,loJID)),-1);
         }
      else
         {
         xmlnode_insert_cdata(loBody,"JID ",-1);
         xmlnode_insert_cdata(loBody,laWords[1],-1);
         xmlnode_insert_cdata(loBody," not found.\r\n",-1);
         }

      liProcess=1;
      }

   // command set
   if (liProcess==0 && j_strcmp(laWords[0],"set")==0 && j_strlen(laWords[1])>0)
      {
      // lcMSG ukazuje na data JIDu kter se maj uloit
      // vygeneruje nod z dat
      loJID=xmlnode_str(lcMSG,j_strlen(lcMSG));

      // ulo nov nod pomoc smtp_roster_set_item(char *lcJID, xmlnode loJID)
      if (loJID!=NULL)
         smtp_roster_set_itemEx(laWords[1],loJID);

      xmlnode_free(loJID);
      liProcess=-1;
      }


   // odstran jid ze souboru + odstran kontakt list
   if (liProcess==0 && j_strcmp(laWords[0],"remove")==0 && j_strlen(laWords[1])>0)
      {
      smtp_roster_remove_item(laWords[1]);
      if (j_strlen(laWords[2])>0 && j_strcmp(laWords[2],"cl")==0)
         smtp_online_remove_item(laWords[1], NULL);

      xmlnode_insert_cdata(loBody,"JID ",-1);
      xmlnode_insert_cdata(loBody,laWords[1],-1);
      xmlnode_insert_cdata(loBody," removed.",-1);
      liProcess=1;
      }

   // - odstran jid ze souboru dle danho psma  + odstran kontakt list
   if (liProcess==0 && j_strcmp(laWords[0],"remove/letter")==0 && j_strlen(laWords[1])>0 && j_strlen(laWords[2])>0)
      {
      // najdi JID v souboru dle  laWords[1]
      // skryj ho
      // ulo soubor rosteru 
      laWords[2]=smtp_getword(&lcMSG, " ",lcMax);
      laWords[3]=smtp_getword(&lcMSG, " ",lcMax);
      if ((loFile=xmlnode_get_tag(jtin->roster_files,spools(p,"file?type=",laWords[1],p)))!=NULL)
         {
         if ((loJID=xmlnode_get_tag(loFile,spools(p,"item?jid=",laWords[2],p)))!=NULL)
            {
            xmlnode_hide(loJID);
            smtp_roster_save_group(laWords[1]);
            }
         }

      if (j_strlen(laWords[3])>0 && j_strcmp(laWords[3],"cl")==0)
         smtp_online_remove_item(laWords[2], NULL);

      xmlnode_insert_cdata(loBody,"JID ",-1);
      xmlnode_insert_cdata(loBody,laWords[2],-1);
      xmlnode_insert_cdata(loBody," removed.",-1);
      liProcess=1;
      }

   // command check
   if (liProcess==0 && j_strcmp(laWords[0],"check")==0)
      {

      for (loFile = xmlnode_get_firstchild(jtin->roster_files); loFile != NULL; loFile = xmlnode_get_nextsibling(loFile))
          {
          if (loFile->type!=NTYPE_TAG)
             continue;


       // walk all jid in file
          for (loJID = xmlnode_get_firstchild(loFile); loJID != NULL; loJID = xmlnode_get_nextsibling(loJID))
              {
              if (loJID->type!=NTYPE_TAG)
                  continue;

              lcJID=xmlnode_get_attrib(loJID,"jid");
              if (lcJID!=NULL)
                 {
                  // otestuj zda je pod sprvnm psmenem
                 lcFrom = (char*)pmalloc_x(p, 2,'\0');
                 lcLetter = (char*)pmalloc_x(p, 4,'\0');
                 if ((lcFrom[0]=lcJID[0])<0)
                    toEscape(lcFrom,(void *)lcLetter,"()<>,;:\"/[]?");
                 else 
                    lcLetter[0]=lcFrom[0];

                 if (j_strcmp(lcLetter,xmlnode_get_attrib(loFile,"type"))!=0)
                    {
                    smtp_SendInfoToAdmin(spools(p,"The account ",lcJID," is under letter ",xmlnode_get_attrib(loFile,"type"),p),SMTP_SITA_M );

                    // ulo ho pod srpvnm psmenem
                    smtp_roster_set_itemEx(lcJID,xmlnode_dup_pool(p,loJID)); //stop AA

                    // Zlikviduj pedchoz uloen
                    xmlnode_hide(loJID);
                    smtp_roster_save_group(xmlnode_get_attrib(loFile,"type"));
                    }
                 }
              else
                 log_alert("smtp","ROSTER - JID not define for item: %s.",xmlnode2str(loJID));
              }
          }
      liProcess=-1;
      }

   if (liProcess==1)
      {
      deliver(dpacket_new(xmlnode_dup(x)),par->i);
      smtp_stats_out(x);
      }
 
   xmlnode_free(x);

   return liProcess;
   }

int _smtp_opmadmin_cl(smtpp par,char *lcJID,char *lcMSG)
   {
/*
// contact list
!cl list - vrt seznam JID dle kontakt list

!cl get [jid] - vrt seznam kontakt pro JID
*/

   int liProcess=0;
   char *laWords[5], *lcMax;
   xmlnode x,loBody;
   smtp_cjid loCL;
   pool p;
   
   lcMax=lcMSG+j_strlen(lcMSG);
   laWords[0]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[1]=smtp_getword(&lcMSG, " ",lcMax);

   x= out_SetReply(xmlnode_new_tag("message"),par->jp->x);
   smtp_PoolsReg(1006, (p=xmlnode_pool(x)));

   xmlnode_put_attrib(x,"type","chat");
   loBody=xmlnode_insert_tag(x,"body");

   // command get
   if (liProcess==0 && j_strcmp(laWords[0],"get")==0 && j_strlen(laWords[1])>0)
      {
      if ((loCL=smtp_cjidGet(laWords[1])))
         {
         xmlnode_insert_cdata(loBody,xmlnode2str(xmlnode_dup_pool(p,loCL->item)),-1);
         xmlnode_insert_cdata(loBody,"\r\n",-1);
         xmlnode_insert_cdata(loBody,xmlnode2str(xmlnode_dup_pool(p,loCL->offitem)),-1);
         liProcess=1;
         }
      }

   if (liProcess==1)
      {
      deliver(dpacket_new(xmlnode_dup(x)),par->i);
      smtp_stats_out(x);
      }
 
   xmlnode_free(x);

   return liProcess;
   }

int _smtp_opmadmin_log(smtpp par,char *lcJID,char *lcMSG)
   {
/*
!log get [datum] - vrt log za konkrtn den
*/

   int liProcess=0,lihFile,liLen,liDone;
   char *laWords[5], *lcMax;
   char lcBuf[BUFSIZ];;
   xmlnode x,loBody;

   lcMax=lcMSG+j_strlen(lcMSG);
   laWords[0]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[1]=smtp_getword(&lcMSG, " ",lcMax);

   x= out_SetReply(xmlnode_new_tag("message"),par->jp->x);
   smtp_PoolsReg(1007, xmlnode_pool(x));

   xmlnode_put_attrib(x,"type","chat");
   loBody=xmlnode_insert_tag(x,"body");

   // command get
   if (liProcess==0 && j_strcmp(laWords[0],"get")==0 && j_strlen(laWords[1])>0)
      {
      // zkontroluj existenci indexovho souboru
      // pokud neexistuje vytvo jej
/*
      lihFile = open(jtin->error_log,O_RDONLY);
      if (lihFile >= 0)
         {
         do {
            liLen = read(lihFile,lcBuf, BUFSIZ);
            liDone = liLen < BUFSIZ;

            xmlnode_insert_cdata(loBody,lcBuf,liLen);
            xmlnode_insert_cdata(loBody,"\r\n",-1);

            // zpracuj dek lcBuf
            }
         while(!liDone);

         liProcess=1;
         close(lihFile);
         }
      else
        xmlnode_insert_cdata(loBody,"cannot open error log",-1);

*/
      }

   if (liProcess==1)
      {
      deliver(dpacket_new(xmlnode_dup(x)),par->i);
      smtp_stats_out(x);
      }
 
   xmlnode_free(x);

   return liProcess;
   }


char* _smtp_opmadmin_keyword(pool p,const char *lcKeyword,char *laCmds[], char *laWords[],int liCntC,int liCntW, int *liFailed)
   {
   // projdi matici laWords[] a detekuj kde je dan klov slovo
   // pokud nsledujc dek obsahuje jin klov slovo
   // vyhodno to jako chybu
   char *lcRet=NULL,*lcPom;
   int lii,liy,liDelta;
   *liFailed=0;

   lii=0;
   while (lii<liCntW)
       { 
       if (j_strlen(laWords[lii])==0)
          break;

       lcPom=strstr(_jabstats_key_singlelist,spools(p,",",laWords[lii],",",p));
       liDelta=lcPom!=NULL?1:2;

       if (j_strcmp(laWords[lii],lcKeyword)==0) // wow, I found keyword
          {
          // check if next cell is another keyword
          if (liDelta==2)
             {
             for (liy=0;liy<liCntC;liy++)
                 { 
                 if (j_strcmp(laCmds[liy],laWords[lii+1])==0) // bad, I found keyword in next cell
                    {
                    *liFailed=1; // 
                    break;
                    }
                 }

             if (*liFailed==0) // If OK
                lcRet=laWords[lii+1];  // then return value
             }
          else
             {
             lcRet=pstrdup(p,"1");  // then return value
             }
          break;
          }

       lii+=liDelta;
       }
   return lcRet; 
   }

int _smtp_opmadmin_jabstats(smtpp par,char *lcJID,char *lcMSG)
   {
/*
!jabstats year YYYY - vrt seznam dn a JID (xml)
!jabstats day YYYY-MM-DD  - vrt JIDy za konkrtn den
!jabstats month MM  - vrt JIDy za msc
!jabstats from blah@bleh.cz  - vrt odeslatele
!jabstats to blah@bleh.cz  - vrt pjemce
!jabstats stepover  - vrt ty co doshli meze

!jabstats countover xx  - vrt ty co doshli/pekroily  meze XX

jednotliv klov slova lze kombinovat
*/

   int liProcess=0,liFailed=0,liDFill=0,liCntW,liCntC;
   char *lcMax,*lcYear=NULL,*lcDate=NULL,*lcFrom=NULL,*lcTo=NULL,*lcMonth=NULL,*lcStepOver=NULL,*lcMonthD;
   char *laWords[11],*laCmds[6];
   xmlnode x,loBody,loYear,loDay,loJID,loTo;
   pool p;
   struct dirent *dirp;
   DIR      *dp;
   
   lcMax=lcMSG+j_strlen(lcMSG);
   laWords[0]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[1]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[2]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[3]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[4]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[5]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[6]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[7]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[8]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[9]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[10]=smtp_getword(&lcMSG, " ",lcMax);


   x= out_SetReply(xmlnode_new_tag("message"),par->jp->x);
   smtp_PoolsReg(1008, (p=xmlnode_pool(x)));

   // keywords list
   laCmds[0]=pstrdup(p,_jabstats_key_year);
   laCmds[1]=pstrdup(p,_jabstats_key_day);
   laCmds[2]=pstrdup(p,_jabstats_key_from);
   laCmds[3]=pstrdup(p,_jabstats_key_month);
   laCmds[4]=pstrdup(p,_jabstats_key_to);
   laCmds[5]=pstrdup(p,_jabstats_key_stepover);

   liCntC=sizeof(laCmds)/sizeof(laCmds[0]);
   liCntW=sizeof(laWords)/sizeof(laWords[0]);

   xmlnode_put_attrib(x,"type","chat");
   loBody=xmlnode_insert_tag(x,"body");

   // zjisti zadan parametry
   lcYear=_smtp_opmadmin_keyword(p,_jabstats_key_year,laCmds,laWords,liCntC,liCntW,&liFailed);
   if (liFailed==0)
      lcDate=_smtp_opmadmin_keyword(p,_jabstats_key_day,laCmds,laWords,liCntC,liCntW,&liFailed);
   if (liFailed==0)
      lcFrom=_smtp_opmadmin_keyword(p,_jabstats_key_from,laCmds,laWords,liCntC,liCntW,&liFailed);
   if (liFailed==0)
      lcMonth=_smtp_opmadmin_keyword(p,_jabstats_key_month,laCmds,laWords,liCntC,liCntW,&liFailed);
   if (liFailed==0)
      lcTo=_smtp_opmadmin_keyword(p,_jabstats_key_to,laCmds,laWords,liCntC,liCntW,&liFailed);
   if (liFailed==0)
      lcStepOver=_smtp_opmadmin_keyword(p,_jabstats_key_stepover,laCmds,laWords,liCntC,liCntW,&liFailed);

   if ((lcYear==NULL && lcDate==NULL && lcFrom==NULL && lcMonth==NULL && lcTo==NULL && lcStepOver==NULL) || liFailed==1)
      liProcess=-1;


   // kdy zn rok, nati rok
   // kdy zn den nati pslun rok
   // jinak projdi vechny soubory ve sloce jtin->jabstats

   // test if any file in folder, if yes, send mesage to all admins
   if (liProcess==0 && (dp = opendir(jtin->jabstats_folder))!=NULL)
      {
      liProcess=1;
      if (lcYear==NULL && lcDate!=NULL)
         {
         lcYear=pstrdup(p,lcDate);
         lcYear[4]='\0';
         }

      xmlnode_insert_cdata(loBody,"<result>",-1);

      while ( (dirp = readdir((DIR *)dp)) != NULL)
            {
            if (strcmp(dirp->d_name, ".") == 0  ||
                strcmp(dirp->d_name, "..") == 0)
               continue;      // ignore dot and dot-dot 

            if (lcYear==NULL || strncmp(lcYear,dirp->d_name,4)==0)
               {
               // read file as XML


               loYear=xmlnode_file(spools(p,jtin->jabstats_folder,"/",dirp->d_name,p));
               if (loYear==NULL)
                  continue;

               smtp_PoolsReg(1009, xmlnode_pool(loYear));
               // pokud zn jen rok, nati jeje cel
               if (lcYear!=NULL && lcDate==NULL && lcFrom==NULL && lcMonth==NULL && lcTo==NULL && lcStepOver==NULL)
                  xmlnode_insert_cdata(loBody,xmlnode2str(xmlnode_dup_pool(p,loYear)),-1);
               else 
                  {
                  xmlnode_insert_cdata(loBody,"<year id='",-1);
                  xmlnode_insert_cdata(loBody,xmlnode_get_attrib(loYear,"id"),-1);
                  xmlnode_insert_cdata(loBody,"'>",-1);
                  // nati vechny
                  if (lcDate!=NULL)
                     loDay=xmlnode_dup_pool(p,xmlnode_get_tag(loYear,spools(p,"day?id=",lcDate,p)));
                  else
                     loDay=xmlnode_get_firstchild(loYear);

                  for (; loDay != NULL; loDay = xmlnode_get_nextsibling(loDay))
                      {
                      // pokud zn msc a ne datum, testuj msc
                      lcMonthD=pstrdup(p,xmlnode_get_attrib(loDay,"id"));
                      lcMonthD+=5;
                      lcMonthD[2]='\0';

                      if (lcMonth!=NULL && j_strcmp(lcMonthD,lcMonth)!=0) // && lcDate==NULL
                         continue;

                      if (lcFrom==NULL && lcTo==NULL && lcStepOver==NULL)
                         xmlnode_insert_cdata(loBody,xmlnode2str(xmlnode_dup_pool(p,loDay)),-1);
                      else 
                         {
                         if (lcFrom!=NULL)
                            loJID=xmlnode_dup_pool(p,xmlnode_get_tag(loDay,spools(p,"jid?from=",lcFrom,p)));
                         else
                            loJID=xmlnode_get_firstchild(loDay);

                         liDFill=0; 
                         for (; loJID != NULL; loJID = xmlnode_get_nextsibling(loJID))
                             {
                             if (lcStepOver!=NULL && j_atoi(xmlnode_get_attrib(loJID,"stepover"),0)==0)
                                continue;

                             if (lcTo==NULL)
                                {
                                if (liDFill==0)
                                   xmlnode_insert_cdata(loBody,spools(p,"<day id='",xmlnode_get_attrib(loDay,"id"),"'>",p),-1);

                                liDFill=1; 
                                xmlnode_insert_cdata(loBody,xmlnode2str(xmlnode_dup_pool(p,loJID)),-1);
                                }
                             else
                                {
                                if ((loTo=xmlnode_get_tag(loJID,spools(p,"recipient?to=",lcTo,p))))
                                   {
                                   if (liDFill==0)
                                      xmlnode_insert_cdata(loBody,spools(p,"<day id='",xmlnode_get_attrib(loDay,"id"),"'>",p),-1);

                                   liDFill=1; 
                                   xmlnode_insert_cdata(loBody,"<jid ",-1);
                                   xmlnode_insert_cdata(loBody,spools(p," from='",xmlnode_get_attrib(loJID,"from"),"'",p),-1);
                                   xmlnode_insert_cdata(loBody,spools(p," count='",xmlnode_get_attrib(loJID,"count"),"'",p),-1);
                                   xmlnode_insert_cdata(loBody,spools(p," stepover='",xmlnode_get_attrib(loJID,"stepover"),"'",p),-1);
                                   xmlnode_insert_cdata(loBody,">",-1);
                                   xmlnode_insert_cdata(loBody,xmlnode2str(xmlnode_dup_pool(p,loTo)),-1);
                                   xmlnode_insert_cdata(loBody,"</jid>",-1);
                                   }
                                }
                             }
                         if (liDFill==1)
                            xmlnode_insert_cdata(loBody,"</day>",-1);
                         }

                      } // next loDay

                  xmlnode_insert_cdata(loBody,"</year>",-1);
                  }

               xmlnode_free(loYear);

               if (lcYear!=NULL)
                  break;
               }
            }
      xmlnode_insert_cdata(loBody,"</result>",-1);
      closedir((DIR *)dp);
      }


   if (liProcess==1)
      {
      deliver(dpacket_new(xmlnode_dup(x)),par->i);
      smtp_stats_out(x);
      }
 
   xmlnode_free(x);

   return liProcess;
   }


int _smtp_opmadmin_smtpstats(smtpp par,char *lcJID,char *lcMSG)
   {
/*
!smtpstats year YYYY - vrt seznam dn a JID (xml)
!smtpstats day YYYY-MM-DD  - vrt JIDy za konkrtn den
!smtpstats month MM  - vrt JIDy za msc
!smtpstats from blah@bleh.cz  - vrt odeslatele
!smtpstats to blah@bleh.cz  - vrt pjemce
!smtpstats stepover  - vrt ty co doshli meze

jednotliv klov slova lze kombinovat
*/

   int liProcess=0,liFailed=0,liDFill=0,liCntW,liCntC;
   char *lcMax,*lcYear=NULL,*lcDate=NULL,*lcFrom=NULL,*lcTo=NULL,*lcMonth=NULL,*lcStepOver=NULL,*lcMonthD;
   char *laWords[11],*laCmds[6];
   xmlnode x,loBody,loYear,loDay,loJID,loTo;
   pool p;
   struct dirent *dirp;
   DIR      *dp;
   
   lcMax=lcMSG+j_strlen(lcMSG);
   laWords[0]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[1]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[2]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[3]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[4]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[5]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[6]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[7]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[8]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[9]=smtp_getword(&lcMSG, " ",lcMax);
   laWords[10]=smtp_getword(&lcMSG, " ",lcMax);

   x= out_SetReply(xmlnode_new_tag("message"),par->jp->x);
   smtp_PoolsReg(1011, (p=xmlnode_pool(x)));

   // keywords list
   laCmds[0]=pstrdup(p,_smtpstats_key_year);
   laCmds[1]=pstrdup(p,_smtpstats_key_day);
   laCmds[2]=pstrdup(p,_smtpstats_key_from);
   laCmds[3]=pstrdup(p,_smtpstats_key_month);
   laCmds[4]=pstrdup(p,_smtpstats_key_to);
   laCmds[5]=pstrdup(p,_smtpstats_key_stepover);

   liCntC=sizeof(laCmds)/sizeof(laCmds[0]);
   liCntW=sizeof(laWords)/sizeof(laWords[0]);

   xmlnode_put_attrib(x,"type","chat");
   loBody=xmlnode_insert_tag(x,"body");

   // zjisti zadan parametry
   lcYear=_smtp_opmadmin_keyword(p,_smtpstats_key_year,laCmds,laWords,liCntC,liCntW,&liFailed);
   if (liFailed==0)
      lcDate=_smtp_opmadmin_keyword(p,_smtpstats_key_day,laCmds,laWords,liCntC,liCntW,&liFailed);
   if (liFailed==0)
      lcFrom=_smtp_opmadmin_keyword(p,_smtpstats_key_from,laCmds,laWords,liCntC,liCntW,&liFailed);
   if (liFailed==0)
      lcMonth=_smtp_opmadmin_keyword(p,_smtpstats_key_month,laCmds,laWords,liCntC,liCntW,&liFailed);
   if (liFailed==0)
      lcTo=_smtp_opmadmin_keyword(p,_smtpstats_key_to,laCmds,laWords,liCntC,liCntW,&liFailed);
   if (liFailed==0)
      lcStepOver=_smtp_opmadmin_keyword(p,_smtpstats_key_stepover,laCmds,laWords,liCntC,liCntW,&liFailed);

   if ((lcYear==NULL && lcDate==NULL && lcFrom==NULL && lcMonth==NULL && lcTo==NULL && lcStepOver==NULL) || liFailed==1)
      liProcess=-1;


   // kdy zn rok, nati rok
   // kdy zn den nati pslun rok
   // jinak projdi vechny soubory ve sloce jtin->jabstats

   // test if any file in folder, if yes, send mesage to all admins
   if (liProcess==0 && (dp = opendir(jtin->smtpstats_folder))!=NULL)
      {
      liProcess=1;
      if (lcYear==NULL && lcDate!=NULL)
         {
         lcYear=pstrdup(p,lcDate);
         lcYear[4]='\0';
         }

      xmlnode_insert_cdata(loBody,"<result>",-1);

      while ( (dirp = readdir((DIR *)dp)) != NULL)
            {
            if (strcmp(dirp->d_name, ".") == 0  ||
                strcmp(dirp->d_name, "..") == 0)
               continue;      // ignore dot and dot-dot 

            if (lcYear==NULL || strncmp(lcYear,dirp->d_name,4)==0)
               {
               // read file as XML
               loYear=xmlnode_file(spools(p,jtin->smtpstats_folder,"/",dirp->d_name,p));
               smtp_PoolsReg(1012, xmlnode_pool(loYear));
               if (loYear==NULL)
                  continue;

               // pokud zn jen rok, nati jeje cel
               if (lcYear!=NULL && lcDate==NULL && lcFrom==NULL && lcMonth==NULL && lcTo==NULL && lcStepOver==NULL)
                  xmlnode_insert_cdata(loBody,xmlnode2str(xmlnode_dup_pool(p,loYear)),-1);
               else 
                  {
                  xmlnode_insert_cdata(loBody,"<year id='",-1);
                  xmlnode_insert_cdata(loBody,xmlnode_get_attrib(loYear,"id"),-1);
                  xmlnode_insert_cdata(loBody,"'>",-1);
                  // nati vechny
                  if (lcDate!=NULL)
                     loDay=xmlnode_dup_pool(p,xmlnode_get_tag(loYear,spools(p,"day?id=",lcDate,p)));
                  else
                     loDay=xmlnode_get_firstchild(loYear);

                  for (; loDay != NULL; loDay = xmlnode_get_nextsibling(loDay))
                      {
                      // pokud zn msc a ne datum, testuj msc
                      lcMonthD=pstrdup(p,xmlnode_get_attrib(loDay,"id"));
                      lcMonthD+=5;
                      lcMonthD[2]='\0';

                      if (lcMonth!=NULL && j_strcmp(lcMonthD,lcMonth)!=0) // && lcDate==NULL
                         continue;

                      if (lcFrom==NULL && lcTo==NULL && lcStepOver==NULL)
                         xmlnode_insert_cdata(loBody,xmlnode2str(xmlnode_dup_pool(p,loDay)),-1);
                      else 
                         {
                         if (lcFrom!=NULL)
                            loJID=xmlnode_dup_pool(p,xmlnode_get_tag(loDay,spools(p,"jid?from=",lcFrom,p)));
                         else
                            loJID=xmlnode_get_firstchild(loDay);

                         liDFill=0; 
                         for (; loJID != NULL; loJID = xmlnode_get_nextsibling(loJID))
                             {
                             if (lcStepOver!=NULL && j_atoi(xmlnode_get_attrib(loJID,"stepover"),0)==0)
                                continue;

                             if (lcTo==NULL)
                                {
                                if (liDFill==0)
                                   xmlnode_insert_cdata(loBody,spools(p,"<day id='",xmlnode_get_attrib(loDay,"id"),"'>",p),-1);

                                liDFill=1; 
                                xmlnode_insert_cdata(loBody,xmlnode2str(xmlnode_dup_pool(p,loJID)),-1);
                                }
                             else
                                {
                                if ((loTo=xmlnode_get_tag(loJID,spools(p,"recipient?to=",lcTo,p))))
                                   {
                                   if (liDFill==0)
                                      xmlnode_insert_cdata(loBody,spools(p,"<day id='",xmlnode_get_attrib(loDay,"id"),"'>",p),-1);

                                   liDFill=1; 
                                   xmlnode_insert_cdata(loBody,"<jid ",-1);
                                   xmlnode_insert_cdata(loBody,spools(p," from='",xmlnode_get_attrib(loJID,"from"),"'",p),-1);
                                   xmlnode_insert_cdata(loBody,spools(p," count='",xmlnode_get_attrib(loJID,"count"),"'",p),-1);
                                   xmlnode_insert_cdata(loBody,spools(p," stepover='",xmlnode_get_attrib(loJID,"stepover"),"'",p),-1);
                                   xmlnode_insert_cdata(loBody,">",-1);
                                   xmlnode_insert_cdata(loBody,xmlnode2str(xmlnode_dup_pool(p,loTo)),-1);
                                   xmlnode_insert_cdata(loBody,"</jid>",-1);
                                   }
                                }
                             }
                         if (liDFill==1)
                            xmlnode_insert_cdata(loBody,"</day>",-1);
                         }

                      } // next loDay

                  xmlnode_insert_cdata(loBody,"</year>",-1);
                  }

               xmlnode_free(loYear);

               if (lcYear!=NULL)
                  break;
               }
            }
      xmlnode_insert_cdata(loBody,"</result>",-1);
      closedir((DIR *)dp);
      }


   if (liProcess==1)
      {
      deliver(dpacket_new(xmlnode_dup(x)),par->i);
      smtp_stats_out(x);
      }
 
   xmlnode_free(x);

   return liProcess;
   }

int smtp_admin_message(smtpp par,char *lcType)
   {
   jpacket jp=par->jp;
   char *lcJID, *lcMSG, *lcSep,*lcData, *lcCmd,*lcMax,*lcERow;
   int liExit=0,liExecute,liMax=0,liLen;

   lcJID=smtp_GetJID(par->tmppool,jid_full(jp->from));
   lcCmd=lcMSG=xmlnode_get_tag_data(jp->x,"body");

   if ((liLen=j_strlen(lcMSG))>0)
      lcMax=lcMSG+liLen;
   else
      return 1;
   
   while (liExit==0)
      {
      liExecute=0;

      // check first letter of next row
      lcERow = strstr(lcMSG,"\r");
      if (lcERow==NULL)
          lcERow = strstr(lcMSG,"\n");

      if (lcERow==NULL)  // nen dn enter, jen jeden dek
         {
         liExecute=liExit=1;
         lcERow=lcMax;
         }
      else
         {
         lcSep=lcERow;
         while ((*lcSep == '\r' || *lcSep == '\n') && lcSep<lcMax) // najdi dal dek
           {lcSep++;}

         if (lcSep>lcMax)
            {
            liExecute=liExit=1;
            }
         else
            // check if next row is command
            if (strncasecmp(lcSep,SMTP_CMDG_TRANSPORT,j_strlen(SMTP_CMDG_TRANSPORT))==0 || 
                strncasecmp(lcSep,SMTP_CMDG_CONFIG,j_strlen(SMTP_CMDG_CONFIG))==0 ||
                strncasecmp(lcSep,SMTP_CMDG_ACCOUNT,j_strlen(SMTP_CMDG_ACCOUNT))==0)
               liExecute=1;
         }

      if (liExit!=1)
         {
         *lcERow='\0'; //ukoni pkaz
         lcMSG=lcSep;
         }


      if (liExecute==1 && lcERow>lcCmd)
         {
         lcSep= strstr(lcCmd," ");
         if (lcSep!=NULL)
            lcData=lcSep+1;
         else
            lcData=NULL;


         lcCmd=smtp_2ws(lcCmd);

         if (lcCmd[0]=='!')
            {
            if (strncasecmp(lcCmd,SMTP_CMDG_TRANSPORT,j_strlen(SMTP_CMDG_TRANSPORT))==0 &&
                _smtp_opm_check_JID(lcJID,SMTP_ADMIN_NS_TRANSPORT)==1)
               _smtp_opmadmin_transport(par,lcJID,lcData);
            else if (strncasecmp(lcCmd,SMTP_CMDG_CONFIG,j_strlen(SMTP_CMDG_CONFIG))==0 &&
                _smtp_opm_check_JID(lcJID,SMTP_ADMIN_NS_CONFIG)==1)
               _smtp_opmadmin_config(par,lcJID,lcData);
            else if (strncasecmp(lcCmd,SMTP_CMDG_ACCOUNT,j_strlen(SMTP_CMDG_ACCOUNT))==0 &&
                _smtp_opm_check_JID(lcJID,SMTP_ADMIN_NS_ACCOUNT)==1)
               _smtp_opmadmin_account(par,lcJID,lcData);
            else if (strncasecmp(lcCmd,SMTP_CMDG_CL,j_strlen(SMTP_CMDG_CL))==0 &&
                _smtp_opm_check_JID(lcJID,SMTP_ADMIN_NS_ACCOUNT)==1)
               _smtp_opmadmin_cl(par,lcJID,lcData);
            else if (strncasecmp(lcCmd,SMTP_CMDG_LOG,j_strlen(SMTP_CMDG_LOG))==0 &&
                _smtp_opm_check_JID(lcJID,SMTP_ADMIN_NS_LOG)==1)
               _smtp_opmadmin_log(par,lcJID,lcData);
            else if (strncasecmp(lcCmd,SMTP_CMDG_JABSTATS,j_strlen(SMTP_CMDG_JABSTATS))==0 &&
                _smtp_opm_check_JID(lcJID,SMTP_ADMIN_NS_JABSTATS)==1)
               _smtp_opmadmin_jabstats(par,lcJID,lcData);
            else if (strncasecmp(lcCmd,SMTP_CMDG_SMTPSTATS,j_strlen(SMTP_CMDG_SMTPSTATS))==0 &&
                _smtp_opm_check_JID(lcJID,SMTP_ADMIN_NS_SMTPSTATS)==1)
               _smtp_opmadmin_smtpstats(par,lcJID,lcData);
            }
         else
            _smtp_out_packets_message_admin(par,SMTP_ADMIN_JID,lcJID,lcMSG);

         }

      if (liExecute==1 && liExit!=1)
          lcCmd=lcMSG;

      liMax++;
      if (liMax>=MAXLOOP)
          break;

      }

   if (liMax>=MAXLOOP)
      {
      log_warn("smtp","ADMIN - Max count of LOOP was exceed.");
      smtp_SendInfoToAdmin("ADMIN - Max count of LOOP was exceed.",SMTP_SITA_P );
      }

   return 1;
   }

