#include <jabberd.h>

//#include <time.h>
//#include <stdio.h>
#include <math.h>
#include <dirent.h>
#include <sys/utsname.h>
//#include <sys/stat.h>
#include <sys/resource.h>
#include <sys/param.h>
//#include <sys/sysinfo.h>
//#include <iconv.h> // http://mir.zyrianes.net/cygwin/release/libiconv/



#define smtp_version "0.5.9.066"
#define smtp_name    "XMPP-SMTP-Transport"


#include "rc_strings.h"

#define MAXLOOP      100000

#define PHASE_NONE -1
#define PHASE_SEND 0
#define PHASE_CMD 1
#define PHASE_DATA 2

#define CMD_UNKNOWN -1
#define CMD_NONE 0
#define CMD_HELO 1
#define CMD_MAIL 2
#define CMD_RCPT 3
#define CMD_DATA 4
#define CMD_NOOP 5
#define CMD_RSET 6
#define CMD_QUIT 7
#define CMD_DATA2 8
#define CMD_RCPTE 31
#define CMD_DATAEND 32
#define CMD_EHLO 9

#define MIME_7BIT 0
#define MIME_8BIT 1
#define MIME_BINARY 2
#define MIME_QUOTED 3
#define MIME_BASE64 4


#define SPAM_OK           0
#define SPAM_NotDefined   1
#define SPAM_Error430   430
#define SPAM_Error570   570

#define SMTP_Relay_Port       25
#define SMTP_Incomming_Port 5225
#define SMTP_TimeOut 30

#define SMTP_DATA_MAX 100000
#define SMTP_FAST_PROCESSING_BUFFER_SIZE 1024

#define SMTP_poolm_timeout  30 // minutes



#define SMTP_JID_ICHS  "\"'<> \t,"

#define NS_COMMANDS    "http://jabber.org/protocol/commands"
#define NS_STATS       "http://jabber.org/protocol/stats"
#define NS_ADDRESS     "http://jabber.org/protocol/address"
#define NS_DISCO_INFO  "http://jabber.org/protocol/disco#info"
#define NS_DISCO_ITEMS "http://jabber.org/protocol/disco#items"
#define NS_DISCO       "http://jabber.org/protocol/disco"
#define NS_CAPS        "http://jabber.org/protocol/caps"
#define NS_XHTML_IM    "http://jabber.org/protocol/xhtml-im"
#define NS_XMPP_PING   "urn:xmpp:ping"
#define NS_IQ_RPC      "jabber:iq:rpc"
#define NS_EML         "xmpp:x:eml"
#define NS_DATA        "jabber:x:data"


#define SMTP_BACKUPSMTP_FOLDER         "./spool/smtp/smtp-b"
#define SMTP_BACKUPJABBER_FOLDER       "./spool/smtp/jabber-b"
#define SMTP_OFFLINESMTP_FOLDER        "./spool/smtp/smtp-o"
#define SMTP_OFFLINEJABBER_FOLDER      "./spool/smtp/jabber-o"
#define SMTP_CORETMP_FOLDER            "./spool/smtp/tmp"
#define SMTP_JABSTATS_FOLDER          "./smtp/jabstats"
#define SMTP_SMTPSTATS_FOLDER          "./smtp/smtpstats"


#define SMTP_STATISTICS_FILE           "./spool/statistics.xml"
#define SMTP_RESOURCE_FILE             "./smtp/resources.xml"
#define SMTP_ROSTER_FILE               "./spool/smtp/roster/roster.xml"
#define SMTP_CONFIG_FILE             "./smpt/config.xml"

#define SMTP_DEFAULT_RELAY             "localhost"


#define SMTP_PGP_ATTACH 0
#define SMTP_PGP_MIME   1
#define SMTP_PGP_NOMIME 2


#define SMTP_PGP_MESSAGE         "PGP MESSAGE"
#define SMTP_PGP_SIGNATURE       "PGP SIGNATURE"
#define SMTP_PGP_SIGNED_MESSAGE  "-----BEGIN PGP SIGNED MESSAGE-----"
#define SMTP_PGP_BEGIN           "-----BEGIN"
#define SMTP_PGP_END             "-----END"

#define SMTP_PGP_sBEGIN          "BEGIN"
#define SMTP_PGP_sEND            "END"
#define SMTP_PGP_MESSAGE_BEGIN   "-----BEGIN PGP MESSAGE-----"
#define SMTP_PGP_SIGNATURE_BEGIN "-----BEGIN PGP SIGNATURE-----"
#define SMTP_PGP_MESSAGE_END     "-----END PGP MESSAGE-----"
#define SMTP_PGP_SIGNATURE_END   "-----END PGP SIGNATURE-----"


#define SMTP_IN_DELIVER_ALL    0
#define SMTP_IN_DELIVER_GLOBAL 1
#define SMTP_IN_DELIVER_USER   2


#define SMTP_ADMIN_JID   0
#define SMTP_ADMIN_EMAIL 1

#define SMTP_ADMIN_NS_JID       "smtp:admin:jid"
#define SMTP_ADMIN_NS_EMAIL     "smtp:admin:email"
#define SMTP_ADMIN_NS_INFOTRACK "smtp:admin:info_track"
#define SMTP_ADMIN_NS_CONFIG    "smtp:admin:config"
#define SMTP_ADMIN_NS_TRANSPORT "smtp:admin:transport"
#define SMTP_ADMIN_NS_ACCOUNT   "smtp:admin:account"
#define SMTP_ADMIN_NS_JABSTATS  "smtp:admin:jabstats"
#define SMTP_ADMIN_NS_SMTPSTATS  "smtp:admin:smtpstats"
#define SMTP_ADMIN_NS_LOG       "smtp:admin:log"

#define SMTP_CMDG_TRANSPORT "!transport"
#define SMTP_CMDG_CONFIG    "!config"
#define SMTP_CMDG_ACCOUNT   "!account"
#define SMTP_CMDG_CL        "!cl"
#define SMTP_CMDG_LOG       "!log"
#define SMTP_CMDG_JABSTATS  "!jabstats"
#define SMTP_CMDG_SMTPSTATS "!smtpstats"


#define SMTP_JABSTATS_DAYMAXLIMIT 100
#define SMTP_SMTPSTATS_DAYMAXLIMIT 100

#define SMTP_CODE_220 220
#define SMTP_CODE_221 221
#define SMTP_CODE_250 250
#define SMTP_CODE_251 251
#define SMTP_CODE_354 354
#define SMTP_CODE_404 404
#define SMTP_CODE_451 451
#define SMTP_CODE_500 500
#define SMTP_CODE_502 502
#define SMTP_CODE_503 503
#define SMTP_CODE_504 504
#define SMTP_CODE_550 550
#define SMTP_CODE_554 554
#define SMTP_CODE_553 553
#define SMTP_CODE_552 552

//#define SMTP_DB
#define SMTP_DEBUG log_notice
//#define SMTP_ZONE "smtp"
//#define SMTP_DEBUG log_debug
#define SMTP_ZONE ZONE

#define __HHUNG log_notice(ZONE,"");



#define SMTP_IN_EMAIL   0
#define SMTP_IN_OFFLINE 1


#define SMTP_QUEUE_X   0
#define SMTP_QUEUE_CB  1

#define SMTP_SITA_P 0
#define SMTP_SITA_M 1

#define __NC

#ifdef __NC
 #define __NC_INIT \
 pool pnc;\
 int liMax=50000000,liMaxi=0;\
 smtp_PoolsReg(9000,pnc=pool_new());

 #define __NC2_INIT \
 pool pnc2;\
 int liMax2=50000000,liMaxi2=0;\
 smtp_PoolsReg(9002,pnc2=pool_new());

 #define __NCX_INIT \
 pool pncX;\
 int liMaxX=50000000,liMaxiX=0;

 #define __NC_BODY \
 liMaxi+=1; \
 if (liMaxi>liMax) \
    { \
    log_alert(ZONE," - NC"); \
    smtp_SendInfoToAdmin(spools(pnc,ZONE," - NC ",pnc ),SMTP_SITA_M); \
    break; \
    } 

 #define __NC2_BODY \
 liMaxi2+=1; \
 if (liMaxi2>liMax2) \
    { \
    log_alert(ZONE," - NC"); \
    smtp_SendInfoToAdmin(spools(pnc2,ZONE," - NC ",pnc2),SMTP_SITA_M); \
    break; \
    } 

 #define __NCX_BODY \
 liMaxiX+=1; \
 if (liMaxiX>liMaxX) \
    { \
    log_alert(ZONE," - NC"); \
    smtp_SendInfoToAdmin(spools(pncX,ZONE," - NC ",pncX),SMTP_SITA_M); \
    break; \
    } 

 #define __NC_RESET liMaxi=0;
 #define __NC2_RESET liMaxi2=0;
 #define __NCX_RESET liMaxiX=0;

 #define __NC_DESTROY pool_free(pnc);
 #define __NC2_DESTROY pool_free(pnc2);

 #define __NCX_TEST liMaxiX>liMaxX

#else
 #define __NC_INIT
 #define __NC_BODY
 #define __NC_RESET
 #define __NC_DESTROY
 #define __NC_TEST 0=1

 #define __NC2_INIT
 #define __NC2_BODY
 #define __NC2_RESET
 #define __NC2_DESTROY

 #define __NCX_INIT
 #define __NCX_BODY
 #define __NCX_RESET

 #define __NCEX_INIT
 #define __NCEX_BODY
 #define __NCEX_RESET
 #define __NCEX_DESTROY
 #define __NCEX_TEST 0=1

#endif


typedef struct smtp_jcmd_struc
{
struct smtp_jcmd_struc *next; /* next item */
void *Data;
char *cSessionID;
int iLevel,iMaxLevel;
pool p;
} *smtp_jcmdq,_smtp_jcmdq;



// Spamlist a AutoSignature - jednotliv dky jsou oddleny pomoc \n
typedef struct smtp_roster_data_struc
{
char *jid,*J2S_RTName,*J2S_RTAddr,*J2S_SRSeparator,*J2S_SRText,*S2J_SRSeparator,*S2J_SRText,*Spamlist,*AutoSignature;
int UseGlobalSettings,Attachments,PGPJabberToMIME,PGPToJabbernonMIMETox,S2J_AllAreSPAM,J2S_RTMode,
    J2S_SRMode,S2J_SRMode;

struct _smtp_rjiddata *next; /* next item*/
struct _smtp_rjiddata *last; /* last item*/

} *smtp_rjiddata,_smtp_rjiddata;

/*
File->next (File)
  ->item->next (item->item)



*/

typedef struct smtp_roster_struc
{
struct smtp_roster_struc *next; /* next item - file*/
struct smtp_roster_struc *last; /* last item - file*/
char *cType; // first char
char *cFile; // XML file
smtp_rjiddata *item; // first item (roster) of list
pool p;
} *smtp_rjid,_smtp_rjid;


typedef struct smtp_contacts_struc
{
struct smtp_contacts_struc *next; /* next item */
struct smtp_contacts_struc *last; /* last item */
xmlnode item;
xmlnode offitem;
char *cJID;
pool p;
int iLogin;
} *smtp_cjid,_smtp_cjid;


typedef struct smtp_pools_struc
{
struct smtp_pools_struc *next; /* next item */
struct smtp_pools_struc *last; /* last item */
pool p; // master pool
pool pl; // pool in list
int index;
int tmp;
time_t tstamp;
void *data;
} *smtp_pools,_smtp_pools;

typedef struct smtp_stats_struct
{

   int JabberMessages,JabberMessagesOut,JabberMessagesOutError,
       SMTPCommandUnknown,SMTPMessages,
	   SMTPMessagesIn,
       SMTPSpam, CoreAccounts,SMTPMaxSize,SMTPNoProcess,SMTPBouncy,SMTPNoRecipient,SMTPSpammers,
       SMTPBadRecipient,SMTPNRRecipient,SMTPBlockedByRecipient,SMTPResent,
       XMPPInAll, XMPPInMessage, XMPPInPresence, XMPPInSN10, XMPPInIQ, XMPPInUnknown,
       XMPPOutAll, XMPPOutMessage, XMPPOutPresence, XMPPOutSN10, XMPPOutIQ, XMPPOutUnknown,
       CPUUsage;

   int Start;
   char *StartLastDatetime;


   int _JabberMessages, _JabberMessagesOut, _JabberMessagesOutError,
       _SMTPCommandUnknown,_SMTPMessages,_SMTPMessagesIn,_SMTPResent,
       _SMTPSpam,_CoreContacts,_CoreContactsOnline,_CoreAccounts,_SMTPMaxSize,_SMTPNoProcess,
       _SMTPBouncy,_SMTPNoRecipient,_SMTPSpammers,_SMTPBadRecipient,_SMTPNRRecipient,_SMTPBlockedByRecipient,
       _XMPPInAll, _XMPPInMessage, _XMPPInPresence, _XMPPInSN10, _XMPPInIQ, _XMPPInUnknown,
       _XMPPOutAll, _XMPPOutMessage, _XMPPOutPresence, _XMPPOutSN10, _XMPPOutIQ, _XMPPOutUnknown;


} *smtp_stats, _smtp_stats;


typedef struct smtp_systemalert_struct
{
int itransport_first,ijabberd_first,itransport_last,ijabberd_last,itransport_reset,ijabberd_reset,icpu_first,icpu_alert;
time_t cpu_time, last_time;
} *smtp_sa, _smtp_sa;


/* smtp parser instance */
typedef struct smtpi_struct
{
   instance i;
   char *server; /* our master server address, if any */
   char *relay; /* the smtp relay delivering our messages for us */
   int relayport; /* the smtp relay port */
//   int timeout; /* how long to wait for an incoming request */
   char *me; /* our default smtp hostname */
   char *met; /* our default smtp transport JID */
   int SMTP_Open; /* if this component is wide open */
   int Jabber_Open; /* if this component is wide open */
   int Spamer_Open; /* if this component is wide open */
   char *spamcheck;
   int jep0033; /* JEP-0033: Extended Stanza Addressing, support */ 
   xmlnode config;
   xmlnode status;
   xdbcache xc;

   int timeout;

   int tmpBackupJabber,tmpBackupSMTP;
   int tmpOfflineJabber,tmpOfflineSMTP;
   int tmpCoreTmp;

   char *error_log; /* error log file name */

   char *config_file; /* config file name */
   char *stat_file; /* Statistics file name */
   char *res_file; /* Resources file name */
   char *jabstats_folder; /* Jabber stats folder */
   char *smtpstats_folder; /* SMTP stats folder */
   char *roster_file; /* Roster file name */
   char *roster_folder; /* Roster folder */

   char *jabber_backup;
   char *jabber_offline;
   char *smtp_backup;
   char *smtp_offline;
   char *core_tmp;

   char *DefaultLang; /* Default language */

   char cSMTP_Status[50];
   char cJabber_Status[50];

   xmlnode jabstats; /* jabstats node */
   xmlnode smtpstats; /* smtpstats node */
   xmlnode memtest; /* memtest node */
   xmlnode resources; /* resources node */
   xmlnode roster; /* roster node */
   xmlnode roster_files; /* roster files node */

   smtp_jcmdq qcmd;
   smtp_cjid ContactList;
   smtp_stats Stats; // statistika
   smtp_pools pools;
   smtp_sa sa; // systemalert

   time_t tStart;

} *smtpi, _smtpi;

/* our 'session' data  - jabber to smtp*/
typedef struct smtps_struct
{
   int phase, timer, lastcmd, iStatus, ircpt,mio_status,iraw;
   char *from;
   char *buffer;
   char *host;
   char *cLastOut;
   jid rcpt;
   mio m;
   pool p;
   xmlnode x, oJID, oAD;
   
   int toPGPMIME,Advertising,SRMode;
   char *SRSeparator, *SRText, *lang;
   
   jpacket jp; // incomming jabber packet
   instance i;
  
} *smtps, _smtps;



/* our 'session' data - smtp to jabber*/
typedef struct smptsi_rcp_struc
{ 
   jid rcpt;
   xmlnode oJID;
   int iErr,Advertising,nonMIME2x,Attachments,UseGlobalSettings,iResent,
       SRMode,S2J_AllAreSPAM,iForwarde,_iForwarde,iSpammer,_iSpammer,_iGSpammer;
   char *SRSeparator, *SRText, *smtpaddr,*Resent;

   struct smptsi_rcp_struc *next; /* for lists of recipients */
} *smptsi_rcp,_smptsi_rcp;


typedef struct smtpsi_struct
{
   int phase,_phase,  lastcmd, iSize, iEnd,iProcessMail,iType,iFastProcessing,iDCRLF ;
   time_t iTimerS, iTimerN;
   char *from;
   char *fromEx;
   char *buffer;
   char *host;
   char *listcc;
   char *listto;
   char *MBody;
   char *cFile;

   smptsi_rcp rcpt;
   smptsi_rcp rcptFD;
   smptsi_rcp rcptSYS;

   mio m;
   pool p,mp;
   xmlnode x,omsg, obody;
   int iPGP;
   xmlnode oAD;

   mtq  q;

   int iMaxSized;

} *smtpsi, _smtpsi;


/* our 'session' data */
typedef struct smtp_param
{
   jpacket jp; // incomming jabber packet
   dpacket dp; // incomming jabber delivery packet
   pool tmppool;
   char *lang;
   mtq  q;

   instance i;
} *smtpp, _smtpp;

typedef struct smtpsx_struct
{
 smtpp par;
 smtps so;
 pool p;
 int state;
 char *cBFile;
 void *gmCB;
 void *gmArg;
 void *gmCBF;
 void *gmArgF;
} *smtpsx, _smtpsx;


/* context for MIME decoding */
typedef struct mimectx_struct
{
   int mimeUsed;
   int mimeEncoding;
   char *mimeCharset;
} *mimectx, _mimectx;


typedef struct smtp_jabber_queue_struc_x
{
xmlnode x; // xmlnode
} *smtp_jq_x,_smtp_jq_x;

typedef struct smtp_jabber_queue_struc_cb
{
void *cb; 
void *arg; 
} *smtp_jq_cb,_smtp_jq_cb;

typedef struct smtp_jabber_queue_struc
{
struct smtp_jabber_queue_struc *next; /* next queue item */
void *Data;
int iType;

} *smtp_jq,_smtp_jq;




typedef struct smtp_thread_universal
{
   pool p;
   mtq  q;
   int *index;
} *smtp_tu, _smtp_tu;



// smtp.c
smtps smtp_new_out(mio m);
smtpsi smtp_new_in(mio m);
smtpsi smtp_new_ino(pool p);
smtpp smtp_param_i(pool p,instance i);
void smtp_SendInfoToAdmin(const char *lcMSG, int liType);
smptsi_rcp smtp_NewRecipient(pool p,jid ojid);
smptsi_rcp smtp_AppendRcpt(smptsi_rcp a, smptsi_rcp b);
void smtp_SetGSpammerRcpt(smptsi_rcp a);
jid smtp_2mx(jid id);
jid smtp_mx2(jid id);

typedef void (*smtp_queue_cb)(void *arg);
typedef void (*smtp_j2s_cb)(smtps so, void *arg);

smtp_jq smtp_NewQueueItem(pool p, int liType);
smtp_jq smtp_AppendQueueItem(smtp_jq a, smtp_jq b);
void smtp_FlushQueue(instance i, smtp_jq item);
void smtp_ClearQueue(smtp_jq item);

smtp_jcmdq smtp_CmdNew();
smtp_jcmdq smtp_CmdAppend(smtp_jcmdq b);
smtp_jcmdq smtp_CmdGet(char *lcSessionID);
void smtp_CmdDel(char *lcSessionID);
int smtp_CmdGetMem();

void smtp_StatsSave();


//poolm.h
int smtp_Pools(int liType,int liIndex,pool pl);
void smtp_PoolsReg(int liIndex,pool p);
void smtp_X_cleanup(void *arg);
int smtp_PoolsGetMem();
result smtp_poolm_daemon(void *arg);
void smtp_PoolsSettmp(pool pl,int liTmp);
void smtp_PoolsSetData(pool pl, void *luData);
void smtp_Pools_item(pool pl,int *liIndex,int *liTmp);
int smtp_Pools_Test(pool pl);


// roster.h
xmlnode smtp_roster_get_item(char *lcJID, int liDefault);
void smtp_roster_set_item(char *lcJID, xmlnode loJID);
void smtp_roster_set_itemEx(char *lcJID, xmlnode loJID);
void smtp_roster_remove_item(char *lcJID);
void smtp_roster_enum( char *lcFC, void *luCB,void *luArg);
void smtp_roster_save_main();
void smtp_roster_save_group(char *lcGroup);
typedef void (*smtp_roster_enum_cb)(void *luArg, char *lcJID);

int smtp_online_add_item( char *lcFrom, char *lcTo);
int smtp_online_remove_item( char *lcFrom, char *lcTo);

smtp_cjid smtp_cjidNew(xmlnode loNode,char *lcJID);
smtp_cjid smtp_cjidGet(char *lcJID);
smtp_cjid smtp_cjidAppend(smtp_cjid b);
void smtp_cjidDel(char *lcJID);
int smtp_cjidGetCount(int liFlag);
int smtp_cjidGetContactsCount();
int smtp_cjidGetMem();

// in.c
void smtp_in_read(mio m, int state, void *arg, char *buffer,int bufsz);
void smtp_in_status(smtpsi si, int liStatus, char *data);
void smtp_in_offline_message(xmlnode loMSG);
smtps smtp_in_recipient_cb(smtps so, void *lugmArg);
smtps smtp_in_recipient_cbf(smtps so, void *lugmArg);
smtps smtp_in_replytosmtp_cb(smtps so, void *lugmArg);
smtps smtp_in_replytosmtp_cbf(smtps so, void *lugmArg);
result smtp_in_daemon(void *arg);
smtps smtp_in_rawmail_cb(smtps so, void *lugmArg);
smtps smtp_in_rawmail_cbf(smtps so, void *lugmArg);
int smtp_in_header_drop(pool p, char *msg, char *header, int structured, spool sp);

// in_spam.c
int smtp_in_spam(smtpsi si, char *msg);


// out.c
result smtp_out_packets(instance i, dpacket p, void *arg);

// out_iq.c
int smtp_out_packets_iq(smtpp par, char *lcType);

// out_iq_register.c
int smtp_out_packets_iq_register(smtpp par, char *type);
void smtp_opiqr_SaveToJID(xmlnode xData,xmlnode loJID);
void smtp_opiqr_FillDataFromJID(pool p, const char *lcGroup,xmlnode xData,xmlnode loJID,char *lcLang);

// out_iq_vcard.c
int smtp_out_packets_iq_vcard(smtpp par, char *type);

// out_iq_gateway.c
int smtp_out_packets_iq_gateway(smtpp par, char *type);

// out_iq_time.c
int smtp_out_packets_iq_time(smtpp par, char *type);

// out_iq_version.c
int smtp_out_packets_iq_version(smtpp par, char *type);

// out_iq_di.c
int smtp_out_packets_iq_di(smtpp par, char *type);

// out_iq_stats.c
int smtp_out_packets_iq_stats(smtpp par, char *type);
void smtp_stats_in(xmlnode x);
void smtp_stats_out(xmlnode x);

// out_presence.c
int smtp_out_packets_presence(smtpp par, char *lcType);

// out_mesage.c
int smtp_out_packets_message(smtpp par, char *lcType);
void smtp_out_offline_message(xmlnode loMSG);
void smtp_out_process_message(smtpp par, void *luCB, void *luArg, void *luCBF, void *luArgF);

// out_admin.c
int smtp_admin_message(smtpp par, char *lcType);
int _smtp_opm_check_JID(char *lcJID,const char *lcNS);
int _smtp_opmadmin_getcntfolder(char *lcFLD,int liOld);
char *_smtp_opmadmin_getfolder(pool p, char *lcFLD);


// out_S10N.c
int smtp_out_packets_S10N(smtpp par, char *lcType);



// offline.c
result smtp_offline_jdaemon(void *arg);
result smtp_offline_sdaemon(void *arg);

// paid.c
result smtp_paid_daemon(void *arg);


// utils.c
char *smtp_alltrim(char *lcChar);
char *smtp_2ws(char *lcChar);
char *smtp_lgstrim(char *lcChar);
char *smtp_strcasestr(char *lcWhere,char *lcWhat);
char *smtp_CMonth(int liMonth);
char *smtp_itoa(pool p, long long liNumber);
char *smtp_ftoa(pool p,float lfNumber);
char *smtp_pttoa(pool p,void *liPointer);
xmlnode out_SetReply(xmlnode loNew, xmlnode loOld);
void smtp_ReplyError(instance i, jpacket loOrig, const char *lcNodeName, const char *lcBody, int liError);
char *smtp_GetDateTime(char *lcDateTime);
char *smtp_GetFolderFromFile(char *lcFolder);
int smtp_CreateFolder(char *lcFolder);
void smtp_xmlnode_move_node(xmlnode loNode, xmlnode loParentOld, xmlnode loParentNew);
char *smtp_rc_GetString(pool p,char *lcLang, int liID);
char *smtp_GetSMTPAddress(char *lcJID);
char *smtp_GetJID(pool p,char *lcJID);
char *smtp_ToUTF8(pool p, char *lcText,const char *charmap);
void fromQP(char *string, void *byteStream);
void toQP(char *string, void *byteStream, int liSoftLines, const char *lcSpec);
void toEscape(char *string, void *byteStream, const char *lcSpec);
void fromEscape(char *string, void *byteStream);
char *smtp_getword(char **lcChar, char *lcSep, char *lcMax);
int smtp_check_list(char *lcItem,xmlnode loItem);
xmlnode smtp_findin_list(char *lcItem,xmlnode loItem);
char *spool_print_pool(pool p,spool s);
dpacket dpacket_copy_pool(pool p, dpacket dp);
char *xmlnode2str_fix(xmlnode node);
char *xmlnode2str_pool(pool p, xmlnode node);

// jabstats.c
void jabstats_add(jpacket jp);

// smtpstats.c
void smtpstats_add(char *lcFrom, char *lcTo);

//void smtp_TEST(smtpp par, jpacket loOrig);

// systemalert.c
result smtp_sa_daemon(void *arg);
